## kyverno.io/v1

Resource Types:

- ClusterPolicy
- GenerateRequest
- Policy

### ClusterPolicy

ClusterPolicy declares validation, mutation, and generation behaviors for matching resources.

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v1`
`kind` string | `ClusterPolicy`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` Spec | Spec declares policy behaviors.
`rules` []Rule | Rules is a list of Rule instances. A Policy contains multiple rules and each rule can validate, mutate, or generate resources.
`applyRules` ApplyRulesType | (Optional) ApplyRules controls how rules in a policy are applied. Rule are processed in the order of declaration. When set to `One` processing stops after a rule has been applied i.e. the rule matches and results in a pass, fail, or error. When set to `All` all rules in the policy are processed. The default is `All`.
`failurePolicy` FailurePolicyType | (Optional) FailurePolicy defines how unexpected policy errors and webhook response timeout errors are handled. Rules within the same policy share the same failure behavior. This field should not be accessed directly, instead `GetFailurePolicy()` should be used. Allowed values are Ignore or Fail. Defaults to Fail.
`validationFailureAction` ValidationFailureAction | (Optional) ValidationFailureAction defines if a validation policy rule violation should block the admission review request (enforce), or allow (audit) the admission review request and report an error in a policy report. Optional. Allowed values are audit or enforce. The default value is “audit”.
`validationFailureActionOverrides` []ValidationFailureActionOverride | (Optional) ValidationFailureActionOverrides is a Cluster Policy attribute that specifies ValidationFailureAction namespace-wise. It overrides ValidationFailureAction for the specified namespaces.
`background` bool | (Optional) Background controls if rules are applied to existing resources during a background scan. Optional. Default value is “true”. The value must be set to “false” if the policy rule uses variables that are only available in the admission review request (e.g. user name).
`schemaValidation` bool | (Optional) SchemaValidation skips validation checks for policies as well as patched resources. Optional. The default value is set to “true”, it must be set to “false” to disable the validation checks.
`webhookTimeoutSeconds` int32 | WebhookTimeoutSeconds specifies the maximum time in seconds allowed to apply this policy. After the configured time expires, the admission request may fail, or may simply ignore the policy results, based on the failure policy. The default timeout is 10s, the value must be between 1 and 30 seconds.
`mutateExistingOnPolicyUpdate` bool | (Optional) MutateExistingOnPolicyUpdate controls if a mutateExisting policy is applied on policy events. Default value is “false”.
`generateExistingOnPolicyUpdate` bool | (Optional) GenerateExistingOnPolicyUpdate controls whether to trigger generate rule in existing resources If is set to “true” generate rule will be triggered and applied to existing matched resources. Defaults to “false” if not specified.
`status` PolicyStatus | (Optional) Status contains policy runtime data.

### GenerateRequest

GenerateRequest is a request to process generate rule.

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v1`
`kind` string | `GenerateRequest`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` GenerateRequestSpec | Spec is the information to identify the generate request.
`policy` string | Specifies the name of the policy.
`resource` ResourceSpec | ResourceSpec is the information to identify the generate request.
`context` GenerateRequestContext | Context …
`status` GenerateRequestStatus | (Optional) Status contains statistics related to generate request.

### Policy

Policy declares validation, mutation, and generation behaviors for matching resources. See: https://kyverno.io/docs/writing-policies/ for more information.

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v1`
`kind` string | `Policy`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` Spec | Spec defines policy behaviors and contains one or more rules.
`rules` []Rule | Rules is a list of Rule instances. A Policy contains multiple rules and each rule can validate, mutate, or generate resources.
`applyRules` ApplyRulesType | (Optional) ApplyRules controls how rules in a policy are applied. Rule are processed in the order of declaration. When set to `One` processing stops after a rule has been applied i.e. the rule matches and results in a pass, fail, or error. When set to `All` all rules in the policy are processed. The default is `All`.
`failurePolicy` FailurePolicyType | (Optional) FailurePolicy defines how unexpected policy errors and webhook response timeout errors are handled. Rules within the same policy share the same failure behavior. This field should not be accessed directly, instead `GetFailurePolicy()` should be used. Allowed values are Ignore or Fail. Defaults to Fail.
`validationFailureAction` ValidationFailureAction | (Optional) ValidationFailureAction defines if a validation policy rule violation should block the admission review request (enforce), or allow (audit) the admission review request and report an error in a policy report. Optional. Allowed values are audit or enforce. The default value is “audit”.
`validationFailureActionOverrides` []ValidationFailureActionOverride | (Optional) ValidationFailureActionOverrides is a Cluster Policy attribute that specifies ValidationFailureAction namespace-wise. It overrides ValidationFailureAction for the specified namespaces.
`background` bool | (Optional) Background controls if rules are applied to existing resources during a background scan. Optional. Default value is “true”. The value must be set to “false” if the policy rule uses variables that are only available in the admission review request (e.g. user name).
`schemaValidation` bool | (Optional) SchemaValidation skips validation checks for policies as well as patched resources. Optional. The default value is set to “true”, it must be set to “false” to disable the validation checks.
`webhookTimeoutSeconds` int32 | WebhookTimeoutSeconds specifies the maximum time in seconds allowed to apply this policy. After the configured time expires, the admission request may fail, or may simply ignore the policy results, based on the failure policy. The default timeout is 10s, the value must be between 1 and 30 seconds.
`mutateExistingOnPolicyUpdate` bool | (Optional) MutateExistingOnPolicyUpdate controls if a mutateExisting policy is applied on policy events. Default value is “false”.
`generateExistingOnPolicyUpdate` bool | (Optional) GenerateExistingOnPolicyUpdate controls whether to trigger generate rule in existing resources If is set to “true” generate rule will be triggered and applied to existing matched resources. Defaults to “false” if not specified.
`status` PolicyStatus | (Optional) Status contains policy runtime information. Deprecated. Policy metrics are available via the metrics endpoint

### APICall

(Appears on: ContextEntry)

APICall defines an HTTP request to the Kubernetes API server. The JSON data retrieved is stored in the context. An APICall contains a URLPath used to perform the HTTP GET request and an optional JMESPath used to transform the retrieved JSON data.

Field | Description
--- | ---
`urlPath` string | URLPath is the URL path to be used in the HTTP GET request to the Kubernetes API server (e.g. “/api/v1/namespaces” or “/apis/apps/v1/deployments”). The format required is the same format used by the `kubectl get --raw` command.
`jmesPath` string | (Optional) JMESPath is an optional JSON Match Expression that can be used to transform the JSON response returned from the API server. For example a JMESPath of “items | length(@)” applied to the API server response to the URLPath “/apis/apps/v1/deployments” will return the total count of deployments across all namespaces.

### AdmissionRequestInfoObject

(Appears on: GenerateRequestContext)

AdmissionRequestInfoObject stores the admission request and operation details

Field | Description
--- | ---
`admissionRequest` string | (Optional)
`operation` Kubernetes admission/v1.Operation | (Optional)

### AnyAllConditions

(Appears on: Attestation, ForEachMutation, ForEachValidation)

AnyAllConditions consists of conditions wrapped denoting a logical criteria to be fulfilled. AnyConditions get fulfilled when at least one of its sub-conditions passes. AllConditions get fulfilled only when all of its sub-conditions pass.

Field | Description
--- | ---
`any` []Condition | (Optional) AnyConditions enable variable-based conditional rule execution. This is useful for finer control of when an rule is applied. A condition can reference object data using JMESPath notation. Here, at least one of the conditions need to pass
`all` []Condition | (Optional) AllConditions enable variable-based conditional rule execution. This is useful for finer control of when an rule is applied. A condition can reference object data using JMESPath notation. Here, all of the conditions need to pass

### ApplyRulesType (`string` alias)

(Appears on: Spec, Spec)

ApplyRulesType controls whether processing stops after one rule is applied or all rules are applied.

### Attestation

(Appears on: ImageVerification, ImageVerification)

Attestation are checks for signed in-toto Statements that are used to verify the image. See https://github.com/in-toto/attestation. Kyverno fetches signed attestations from the OCI registry and decodes them into a list of Statements.

Field | Description
--- | ---
`predicateType` string | PredicateType defines the type of Predicate contained within the Statement.
`attestors` []AttestorSet | Attestors specify the required attestors (i.e. authorities)
`conditions` []AnyAllConditions | (Optional) Conditions are used to verify attributes within a Predicate. If no Conditions are specified the attestation check is satisfied as long there are predicates that match the predicate type.

### Attestor

(Appears on: AttestorSet)

Field | Description
--- | ---
`keys` StaticKeyAttestor | Keys specifies one or more public keys
`certificates` CertificateAttestor | Certificates specifies one or more certificates
`keyless` KeylessAttestor | Keyless is a set of attribute used to verify a Sigstore keyless attestor. See https://github.com/sigstore/cosign/blob/main/KEYLESS.md.
`attestor` Kubernetes apiextensions/v1.JSON | Attestor is a nested AttestorSet used to specify a more complex set of match authorities
`annotations` map[string]string | Annotations are used for image verification. Every specified key-value pair must exist and match in the verified payload. The payload may contain other key-value pairs.
`repository` string | Repository is an optional alternate OCI repository to use for signatures and attestations that match this rule. If specified Repository will override other OCI image repository locations for this Attestor.

### AttestorSet

(Appears on: Attestation, ImageVerification, Manifests, ImageVerification)

Field | Description
--- | ---
`count` int | Count specifies the required number of entries that must match. If the count is null, all entries must match (a logical AND). If the count is 1, at least one entry must match (a logical OR). If the count contains a value N, then N must be less than or equal to the size of entries, and at least N entries must match.
`entries` []Attestor | Entries contains the available attestors. An attestor can be a static key, attributes for keyless verification, or a nested attestor declaration.

### AutogenStatus

(Appears on: PolicyStatus)

AutogenStatus contains autogen status information.

Field | Description
--- | ---
`rules` []Rule | Rules is a list of Rule instances. It contains auto generated rules added for pod controllers

### CTLog

(Appears on: CertificateAttestor, KeylessAttestor, StaticKeyAttestor)

Field | Description
--- | ---
`url` string | URL is the address of the transparency log. Defaults to the public log https://rekor.sigstore.dev.

### CertificateAttestor

(Appears on: Attestor)

Field | Description
--- | ---
`cert` string | Certificate is an optional PEM encoded public certificate.
`certChain` string | CertificateChain is an optional PEM encoded set of certificates used to verify
`rekor` CTLog | Rekor provides configuration for the Rekor transparency log service. If the value is nil, Rekor is not checked. If an empty object is provided the public instance of Rekor (https://rekor.sigstore.dev) is used.

### CloneFrom

(Appears on: Generation)

CloneFrom provides the location of the source resource used to generate target resources. The resource kind is derived from the match criteria.

Field | Description
--- | ---
`namespace` string | (Optional) Namespace specifies source resource namespace.
`name` string | Name specifies name of the resource.

### Condition

(Appears on: AnyAllConditions)

Condition defines variable-based conditional criteria for rule execution.

Field | Description
--- | ---
`key` Kubernetes apiextensions/v1.JSON | Key is the context entry (using JMESPath) for conditional rule evaluation.
`operator` ConditionOperator | Operator is the conditional operation to perform. Valid operators are: Equals, NotEquals, In, AnyIn, AllIn, NotIn, AnyNotIn, AllNotIn, GreaterThanOrEquals, GreaterThan, LessThanOrEquals, LessThan, DurationGreaterThanOrEquals, DurationGreaterThan, DurationLessThanOrEquals, DurationLessThan
`value` Kubernetes apiextensions/v1.JSON | (Optional) Value is the conditional value, or set of values. The values can be fixed set or can be variables declared using JMESPath.

### ConditionOperator (`string` alias)

(Appears on: Condition)

ConditionOperator is the operation performed on condition key and value.

### ConfigMapReference

(Appears on: ContextEntry)

ConfigMapReference refers to a ConfigMap

Field | Description
--- | ---
`name` string | Name is the ConfigMap name.
`namespace` string | Namespace is the ConfigMap namespace.

### ContextEntry

(Appears on: ForEachMutation, ForEachValidation, Rule, Rule)

ContextEntry adds variables and data sources to a rule Context. Either a ConfigMap reference or a APILookup must be provided.

Field | Description
--- | ---
`name` string | Name is the variable name.
`configMap` ConfigMapReference | ConfigMap is the ConfigMap reference.
`apiCall` APICall | APICall defines an HTTP request to the Kubernetes API server. The JSON data retrieved is stored in the context.
`imageRegistry` ImageRegistry | ImageRegistry defines requests to an OCI/Docker V2 registry to fetch image details.
`variable` Variable | Variable defines an arbitrary JMESPath context variable that can be defined inline.

### Deny

(Appears on: ForEachValidation, Validation)

Deny specifies a list of conditions used to pass or fail a validation rule.

Field | Description
--- | ---
`conditions` Kubernetes apiextensions/v1.JSON | Multiple conditions can be declared under an `any` or `all` statement. A direct list of conditions (without `any` or `all` statements) is also supported for backwards compatibility but will be deprecated in the next major release. See: https://kyverno.io/docs/writing-policies/validate/#deny-rules

### DryRunOption

(Appears on: Manifests)

DryRunOption is a configuration for dryrun. If enable is set to “true”, manifest verification performs “dryrun & compare” which provides robust matching against changes by defaults and other admission controllers. Dryrun requires additional permissions. See config/dryrun/dryrun_rbac.yaml

Field | Description
--- | ---
`enable` bool |
`namespace` string |

### FailurePolicyType (`string` alias)

(Appears on: Spec, Spec)

FailurePolicyType specifies a failure policy that defines how unrecognized errors from the admission endpoint are handled.

### ForEachMutation

(Appears on: Mutation)

ForEach applies mutation rules to a list of sub-elements by creating a context for each entry in the list and looping over it to apply the specified logic.

Field | Description
--- | ---
`list` string | List specifies a JMESPath expression that results in one or more elements to which the validation logic is applied.
`context` []ContextEntry | (Optional) Context defines variables and data sources that can be used during rule execution.
`preconditions` AnyAllConditions | (Optional) AnyAllConditions are used to determine if a policy rule should be applied by evaluating a set of conditions. The declaration can contain nested `any` or `all` statements. See: https://kyverno.io/docs/writing-policies/preconditions/
`patchStrategicMerge` Kubernetes apiextensions/v1.JSON | (Optional) PatchStrategicMerge is a strategic merge patch used to modify resources. See https://kubernetes.io/docs/tasks/manage-kubernetes-objects/update-api-object-kubectl-patch/ and https://kubectl.docs.kubernetes.io/references/kustomize/patchesstrategicmerge/.
`patchesJson6902` string | (Optional) PatchesJSON6902 is a list of RFC 6902 JSON Patch declarations used to modify resources. See https://tools.ietf.org/html/rfc6902 and https://kubectl.docs.kubernetes.io/references/kustomize/patchesjson6902/.

### ForEachValidation

(Appears on: Validation, Validation)

ForEach applies validate rules to a list of sub-elements by creating a context for each entry in the list and looping over it to apply the specified logic.

Field | Description
--- | ---
`list` string | List specifies a JMESPath expression that results in one or more elements to which the validation logic is applied.
`elementScope` bool | (Optional) ElementScope specifies whether to use the current list element as the scope for validation. Defaults to “true” if not specified. When set to “false”, “request.object” is used as the validation scope within the foreach block to allow referencing other elements in the subtree.
`context` []ContextEntry | (Optional) Context defines variables and data sources that can be used during rule execution.
`preconditions` AnyAllConditions | (Optional) AnyAllConditions are used to determine if a policy rule should be applied by evaluating a set of conditions. The declaration can contain nested `any` or `all` statements. See: https://kyverno.io/docs/writing-policies/preconditions/
`pattern` Kubernetes apiextensions/v1.JSON | (Optional) Pattern specifies an overlay-style pattern used to check resources.
`anyPattern` Kubernetes apiextensions/v1.JSON | (Optional) AnyPattern specifies list of validation patterns. At least one of the patterns must be satisfied for the validation rule to succeed.
`deny` Deny | (Optional) Deny defines conditions used to pass or fail a validation rule.

### GenerateRequestContext

(Appears on: GenerateRequestSpec)

GenerateRequestContext stores the context to be shared.

Field | Description
--- | ---
`userInfo` RequestInfo | (Optional)
`admissionRequestInfo` AdmissionRequestInfoObject | (Optional)

### GenerateRequestSpec

(Appears on: GenerateRequest)

GenerateRequestSpec stores the request specification.

Field | Description
--- | ---
`policy` string | Specifies the name of the policy.
`resource` ResourceSpec | ResourceSpec is the information to identify the generate request.
`context` GenerateRequestContext | Context …

### GenerateRequestState (`string` alias)

(Appears on: GenerateRequestStatus)

GenerateRequestState defines the state of request.

### GenerateRequestStatus

(Appears on: GenerateRequest)

GenerateRequestStatus stores the status of generated request.

Field | Description
--- | ---
`state` GenerateRequestState | State represents state of the generate request.
`message` string | (Optional) Specifies request status message.
`generatedResources` []ResourceSpec | This will track the resources that are generated by the generate Policy. Will be used during clean up resources.

### Generation

(Appears on: Rule, Rule)

Generation defines how new resources should be created and managed.

Field | Description
--- | ---
`ResourceSpec` ResourceSpec | ResourceSpec contains information to select the resource.
`synchronize` bool | (Optional) Synchronize controls if generated resources should be kept in-sync with their source resource. If Synchronize is set to “true” changes to generated resources will be overwritten with resource data from Data or the resource specified in the Clone declaration. Optional. Defaults to “false” if not specified.
`data` Kubernetes apiextensions/v1.JSON | (Optional) Data provides the resource declaration used to populate each generated resource. At most one of Data or Clone must be specified. If neither are provided, the generated resource will be created with default data only.
`clone` CloneFrom | (Optional) Clone specifies the source resource used to populate each generated resource. At most one of Data or Clone can be specified. If neither are provided, the generated resource will be created with default data only.
`cloneList` CloneList | (Optional) CloneList specifies the list of source resource used to populate each generated resource.

### ImageExtractorConfig

Field | Description
--- | ---
`path` string | Path is the path to the object containing the image field in a custom resource. It should be slash-separated. Each slash-separated key must be a valid YAML key or a wildcard ‘*’. Wildcard keys are expanded in case of arrays or objects.
`value` string | (Optional) Value is an optional name of the field within ‘path’ that points to the image URI. This is useful when a custom ‘key’ is also defined.
`name` string | (Optional) Name is the entry the image will be available under ‘images.’ in the context. If this field is not defined, image entries will appear under ‘images.custom’.
`key` string | (Optional) Key is an optional name of the field within ‘path’ that will be used to uniquely identify an image. Note - this field MUST be unique.

### ImageExtractorConfigs (`map[string][]github.com/kyverno/kyverno/api/kyverno/v1.ImageExtractorConfig` alias)

(Appears on: Rule, Rule)

### ImageRegistry

(Appears on: ContextEntry)

ImageRegistry defines requests to an OCI/Docker V2 registry to fetch image details.

Field | Description
--- | ---
`reference` string | Reference is image reference to a container image in the registry. Example: ghcr.io/kyverno/kyverno:latest
`jmesPath` string | (Optional) JMESPath is an optional JSON Match Expression that can be used to transform the ImageData struct returned as a result of processing the image reference.

### ImageVerification

(Appears on: Rule)

ImageVerification validates that images that match the specified pattern are signed with the supplied public key. Once the image is verified it is mutated to include the SHA digest retrieved during the registration.

Field | Description
--- | ---
`image` string | Image is the image name consisting of the registry address, repository, image, and tag. Wildcards (‘*’ and ‘?’) are allowed. See: https://kubernetes.io/docs/concepts/containers/images. Deprecated. Use ImageReferences instead.
`imageReferences` []string | ImageReferences is a list of matching image reference patterns. At least one pattern in the list must match the image for the rule to apply. Each image reference consists of a registry address (defaults to docker.io), repository, image, and tag (defaults to latest). Wildcards (‘*’ and ‘?’) are allowed. See: https://kubernetes.io/docs/concepts/containers/images.
`key` string | Key is the PEM encoded public key that the image or attestation is signed with. Deprecated. Use StaticKeyAttestor instead.
`roots` string | Roots is the PEM encoded Root certificate chain used for keyless signing Deprecated. Use KeylessAttestor instead.
`subject` string | Subject is the identity used for keyless signing, for example an email address Deprecated. Use KeylessAttestor instead.
`issuer` string | Issuer is the certificate issuer used for keyless signing. Deprecated. Use KeylessAttestor instead.
`additionalExtensions` map[string]string | AdditionalExtensions are certificate-extensions used for keyless signing. Deprecated.
`attestors` []AttestorSet | Attestors specified the required attestors (i.e. authorities)
`attestations` []Attestation | Attestations are optional checks for signed in-toto Statements used to verify the image. See https://github.com/in-toto/attestation. Kyverno fetches signed attestations from the OCI registry and decodes them into a list of Statement declarations.
`annotations` map[string]string | Annotations are used for image verification. Every specified key-value pair must exist and match in the verified payload. The payload may contain other key-value pairs. Deprecated. Use annotations per Attestor instead.
`repository` string | Repository is an optional alternate OCI repository to use for image signatures and attestations that match this rule. If specified Repository will override the default OCI image repository configured for the installation. The repository can also be overridden per Attestor or Attestation.
`mutateDigest` bool | MutateDigest enables replacement of image tags with digests. Defaults to true.
`verifyDigest` bool | VerifyDigest validates that images have a digest.
`required` bool | Required validates that images are verified i.e. have matched passed a signature or attestation check.

### KeylessAttestor

(Appears on: Attestor)

Field | Description
--- | ---
`rekor` CTLog | Rekor provides configuration for the Rekor transparency log service. If the value is nil, Rekor is not checked and a root certificate chain is expected instead. If an empty object is provided the public instance of Rekor (https://rekor.sigstore.dev) is used.
`issuer` string | Issuer is the certificate issuer used for keyless signing.
`subject` string | Subject is the verified identity used for keyless signing, for example the email address
`roots` string | Roots is an optional set of PEM encoded trusted root certificates. If not provided, the system roots are used.
`additionalExtensions` map[string]string | AdditionalExtensions are certificate-extensions used for keyless signing.

### Manifests

(Appears on: Validation, Validation)

Field | Description
--- | ---
`attestors` []AttestorSet | Attestors specified the required attestors (i.e. authorities)
`annotationDomain` string | (Optional) AnnotationDomain is custom domain of annotation for message and signature. Default is “cosign.sigstore.dev”.
`ignoreFields` IgnoreFieldList | (Optional) Fields which will be ignored while comparing manifests.
`dryRun` DryRunOption | (Optional) DryRun configuration
`repository` string | Repository is an optional alternate OCI repository to use for resource bundle reference. The repository can be overridden per Attestor or Attestation.

### MatchResources

(Appears on: Rule)

MatchResources is used to specify resource and admission review request data for which a policy rule is applicable.

Field | Description
--- | ---
`any` ResourceFilters | (Optional) Any allows specifying resources which will be ORed
`all` ResourceFilters | (Optional) All allows specifying resources which will be ANDed
`UserInfo` UserInfo | (Optional) UserInfo contains information about the user performing the operation. Specifying UserInfo directly under match is being deprecated. Please specify under “any” or “all” instead.
`resources` ResourceDescription | (Optional) ResourceDescription contains information about the resource being created or modified. Requires at least one tag to be specified when under MatchResources. Specifying ResourceDescription directly under match is being deprecated. Please specify under “any” or “all” instead.

### Mutation

(Appears on: Rule, Rule)

Mutation defines how resource are modified.

Field | Description
--- | ---
`targets` []ResourceSpec | (Optional) Targets defines the target resources to be mutated.
`patchStrategicMerge` Kubernetes apiextensions/v1.JSON | (Optional) PatchStrategicMerge is a strategic merge patch used to modify resources. See https://kubernetes.io/docs/tasks/manage-kubernetes-objects/update-api-object-kubectl-patch/ and https://kubectl.docs.kubernetes.io/references/kustomize/patchesstrategicmerge/.
`patchesJson6902` string | (Optional) PatchesJSON6902 is a list of RFC 6902 JSON Patch declarations used to modify resources. See https://tools.ietf.org/html/rfc6902 and https://kubectl.docs.kubernetes.io/references/kustomize/patchesjson6902/.
`foreach` []ForEachMutation | (Optional) ForEach applies mutation rules to a list of sub-elements by creating a context for each entry in the list and looping over it to apply the specified logic.

### ObjectFieldBinding

Field | Description
--- | ---
`fields` []string |
`objects` github.com/sigstore/k8s-manifest-sigstore/pkg/k8smanifest.ObjectReferenceList |

### PodSecurity

(Appears on: Validation, Validation)

PodSecurity applies exemptions for Kubernetes Pod Security admission by specifying exclusions for Pod Security Standards controls.

Field | Description
--- | ---
`level` k8s.io/pod-security-admission/api.Level | Level defines the Pod Security Standard level to be applied to workloads. Allowed values are privileged, baseline, and restricted.
`version` string | (Optional) Version defines the Pod Security Standard versions that Kubernetes supports. Allowed values are v1.19, v1.20, v1.21, v1.22, v1.23, v1.24, v1.25, latest. Defaults to latest.
`exclude` []PodSecurityStandard | Exclude specifies the Pod Security Standard controls to be excluded.

### PodSecurityStandard

(Appears on: PodSecurity)

PodSecurityStandard specifies the Pod Security Standard controls to be excluded.

Field | Description
--- | ---
`controlName` string | ControlName specifies the name of the Pod Security Standard control. See: https://kubernetes.io/docs/concepts/security/pod-security-standards/
`images` []string | (Optional) Images selects matching containers and applies the container level PSS. Each image is the image name consisting of the registry address, repository, image, and tag. Empty list matches no containers, PSS checks are applied at the pod level only. Wildcards (‘*’ and ‘?’) are allowed. See: https://kubernetes.io/docs/concepts/containers/images.

### PolicyInterface

PolicyInterface abstracts the concrete policy type (Policy vs ClusterPolicy)

### PolicyStatus

(Appears on: ClusterPolicy, Policy, ClusterPolicy, Policy)

PolicyStatus mostly contains runtime information related to policy execution. Deprecated. Policy metrics are now available via the “/metrics” endpoint. See: https://kyverno.io/docs/monitoring-kyverno-with-prometheus-metrics/

Field | Description
--- | ---
`ready` bool | Ready indicates if the policy is ready to serve the admission request. Deprecated in favor of Conditions
`conditions` []Kubernetes meta/v1.Condition | (Optional) Conditions is a list of conditions that apply to the policy
`autogen` AutogenStatus | (Optional) Autogen contains autogen status information
`rulecount` RuleCountStatus | (Optional) RuleCount describes total number of rules in a policy

### RequestInfo

(Appears on: GenerateRequestContext)

RequestInfo contains permission info carried in an admission request.

Field | Description
--- | ---
`roles` []string | (Optional) Roles is a list of possible role send the request.
`clusterRoles` []string | (Optional) ClusterRoles is a list of possible clusterRoles send the request.
`userInfo` Kubernetes authentication/v1.UserInfo | (Optional) UserInfo is the userInfo carried in the admission request.

### ResourceDescription

(Appears on: MatchResources, ResourceFilter)

ResourceDescription contains criteria used to match resources.

Field | Description
--- | ---
`kinds` []string | (Optional) Kinds is a list of resource kinds.
`name` string | (Optional) Name is the name of the resource. The name supports wildcard characters “*” (matches zero or many characters) and “?” (at least one character). NOTE: “Name” is being deprecated in favor of “Names”.
`names` []string | (Optional) Names are the names of the resources. Each name supports wildcard characters “*” (matches zero or many characters) and “?” (at least one character).
`namespaces` []string | (Optional) Namespaces is a list of namespaces names. Each name supports wildcard characters “*” (matches zero or many characters) and “?” (at least one character).
`annotations` map[string]string | (Optional) Annotations is a map of annotations (key-value pairs of type string). Annotation keys and values support the wildcard characters “*” (matches zero or many characters) and “?” (matches at least one character).
`selector` Kubernetes meta/v1.LabelSelector | (Optional) Selector is a label selector. Label keys and values in `matchLabels` support the wildcard characters `*` (matches zero or many characters) and `?` (matches one character). Wildcards allows writing label selectors like [“storage.k8s.io/”: “”]. Note that using [”” : “”] matches any key and value but does not match an empty label set.
`namespaceSelector` Kubernetes meta/v1.LabelSelector | (Optional) NamespaceSelector is a label selector for the resource namespace. Label keys and values in `matchLabels` support the wildcard characters `*` (matches zero or many characters) and `?` (matches one character).Wildcards allows writing label selectors like [“storage.k8s.io/”: “”]. Note that using [”” : “”] matches any key and value but does not match an empty label set.

### ResourceFilter

ResourceFilter allow users to “AND” or “OR” between resources

Field | Description
--- | ---
`UserInfo` UserInfo | (Optional) UserInfo contains information about the user performing the operation.
`resources` ResourceDescription | ResourceDescription contains information about the resource being created or modified.

### ResourceFilters (`[]github.com/kyverno/kyverno/api/kyverno/v1.ResourceFilter` alias)

(Appears on: MatchResources, MatchResources)

ResourceFilters is a slice of ResourceFilter

### ResourceSpec

(Appears on: GenerateRequestSpec, GenerateRequestStatus, Generation, Mutation, UpdateRequestSpec, UpdateRequestStatus)

Field | Description
--- | ---
`apiVersion` string | (Optional) APIVersion specifies resource apiVersion.
`kind` string | Kind specifies resource kind.
`namespace` string | (Optional) Namespace specifies resource namespace.
`name` string | (Optional) Name specifies the resource name.

### Rule

(Appears on: AutogenStatus, Spec)

Rule defines a validation, mutation, or generation control for matching resources. Each rules contains a match declaration to select resources, and an optional exclude declaration to specify which resources to exclude.

Field | Description
--- | ---
`name` string | Name is a label to identify the rule, It must be unique within the policy.
`context` []ContextEntry | (Optional) Context defines variables and data sources that can be used during rule execution.
`match` MatchResources | MatchResources defines when this policy rule should be applied. The match criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the user name or role. At least one kind is required.
`exclude` MatchResources | (Optional) ExcludeResources defines when this policy rule should not be applied. The exclude criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the name or role.
`imageExtractors` ImageExtractorConfigs | (Optional) ImageExtractors defines a mapping from kinds to ImageExtractorConfigs. This config is only valid for verifyImages rules.
`preconditions` Kubernetes apiextensions/v1.JSON | (Optional) Preconditions are used to determine if a policy rule should be applied by evaluating a set of conditions. The declaration can contain nested `any` or `all` statements. A direct list of conditions (without `any` or `all` statements is supported for backwards compatibility but will be deprecated in the next major release. See: https://kyverno.io/docs/writing-policies/preconditions/
`mutate` Mutation | (Optional) Mutation is used to modify matching resources.
`validate` Validation | (Optional) Validation is used to validate matching resources.
`generate` Generation | (Optional) Generation is used to create new resources.
`verifyImages` []ImageVerification | (Optional) VerifyImages is used to verify image signatures and mutate them to add a digest

### RuleCountStatus

(Appears on: PolicyStatus)

RuleCountStatus contains four variables which describes counts for validate, generate, mutate and verify images rules

Field | Description
--- | ---
`validate` int | Count for validate rules in policy
`generate` int | Count for generate rules in policy
`mutate` int | Count for mutate rules in policy
`verifyimages` int | Count for verify image rules in policy

### SecretReference

(Appears on: StaticKeyAttestor)

Field | Description
--- | ---
`name` string | Name of the secret. The provided secret must contain a key named cosign.pub.
`namespace` string | Namespace name where the Secret exists.

### Spec

(Appears on: ClusterPolicy, Policy)

Spec contains a list of Rule instances and other policy controls.

Field | Description
--- | ---
`rules` []Rule | Rules is a list of Rule instances. A Policy contains multiple rules and each rule can validate, mutate, or generate resources.
`applyRules` ApplyRulesType | (Optional) ApplyRules controls how rules in a policy are applied. Rule are processed in the order of declaration. When set to `One` processing stops after a rule has been applied i.e. the rule matches and results in a pass, fail, or error. When set to `All` all rules in the policy are processed. The default is `All`.
`failurePolicy` FailurePolicyType | (Optional) FailurePolicy defines how unexpected policy errors and webhook response timeout errors are handled. Rules within the same policy share the same failure behavior. This field should not be accessed directly, instead `GetFailurePolicy()` should be used. Allowed values are Ignore or Fail. Defaults to Fail.
`validationFailureAction` ValidationFailureAction | (Optional) ValidationFailureAction defines if a validation policy rule violation should block the admission review request (enforce), or allow (audit) the admission review request and report an error in a policy report. Optional. Allowed values are audit or enforce. The default value is “audit”.
`validationFailureActionOverrides` []ValidationFailureActionOverride | (Optional) ValidationFailureActionOverrides is a Cluster Policy attribute that specifies ValidationFailureAction namespace-wise. It overrides ValidationFailureAction for the specified namespaces.
`background` bool | (Optional) Background controls if rules are applied to existing resources during a background scan. Optional. Default value is “true”. The value must be set to “false” if the policy rule uses variables that are only available in the admission review request (e.g. user name).
`schemaValidation` bool | (Optional) SchemaValidation skips validation checks for policies as well as patched resources. Optional. The default value is set to “true”, it must be set to “false” to disable the validation checks.
`webhookTimeoutSeconds` int32 | WebhookTimeoutSeconds specifies the maximum time in seconds allowed to apply this policy. After the configured time expires, the admission request may fail, or may simply ignore the policy results, based on the failure policy. The default timeout is 10s, the value must be between 1 and 30 seconds.
`mutateExistingOnPolicyUpdate` bool | (Optional) MutateExistingOnPolicyUpdate controls if a mutateExisting policy is applied on policy events. Default value is “false”.
`generateExistingOnPolicyUpdate` bool | (Optional) GenerateExistingOnPolicyUpdate controls whether to trigger generate rule in existing resources If is set to “true” generate rule will be triggered and applied to existing matched resources. Defaults to “false” if not specified.

### StaticKeyAttestor

(Appears on: Attestor)

Field | Description
--- | ---
`publicKeys` string | Keys is a set of X.509 public keys used to verify image signatures. The keys can be directly specified or can be a variable reference to a key specified in a ConfigMap (see https://kyverno.io/docs/writing-policies/variables/). When multiple keys are specified each key is processed as a separate staticKey entry (.attestors[*].entries.keys) within the set of attestors and the count is applied across the keys.
`signatureAlgorithm` string | Specify signature algorithm for public keys. Supported values are sha256 and sha512
`kms` string | KMS provides the URI to the public key stored in a Key Management System. See: https://github.com/sigstore/cosign/blob/main/KMS.md
`secret` SecretReference | Reference to a Secret resource that contains a public key
`rekor` CTLog | Rekor provides configuration for the Rekor transparency log service. If the value is nil, Rekor is not checked. If an empty object is provided the public instance of Rekor (https://rekor.sigstore.dev) is used.

### UserInfo

(Appears on: MatchResources, ResourceFilter, ResourceFilter)

UserInfo contains information about the user performing the operation.

Field | Description
--- | ---
`roles` []string | (Optional) Roles is the list of namespaced role names for the user.
`clusterRoles` []string | (Optional) ClusterRoles is the list of cluster-wide role names for the user.
`subjects` []Kubernetes rbac/v1.Subject | (Optional) Subjects is the list of subject names like users, user groups, and service accounts.

### Validation

(Appears on: Rule)

Validation defines checks to be performed on matching resources.

Field | Description
--- | ---
`message` string | (Optional) Message specifies a custom message to be displayed on failure.
`manifests` Manifests | (Optional) Manifest specifies conditions for manifest verification
`foreach` []ForEachValidation | (Optional) ForEach applies validate rules to a list of sub-elements by creating a context for each entry in the list and looping over it to apply the specified logic.
`pattern` Kubernetes apiextensions/v1.JSON | (Optional) Pattern specifies an overlay-style pattern used to check resources.
`anyPattern` Kubernetes apiextensions/v1.JSON | (Optional) AnyPattern specifies list of validation patterns. At least one of the patterns must be satisfied for the validation rule to succeed.
`deny` Deny | (Optional) Deny defines conditions used to pass or fail a validation rule.
`podSecurity` PodSecurity | (Optional) PodSecurity applies exemptions for Kubernetes Pod Security admission by specifying exclusions for Pod Security Standards controls.

### ValidationFailureAction (`string` alias)

(Appears on: Spec, ValidationFailureActionOverride, Spec)

ValidationFailureAction defines the policy validation failure action

### ValidationFailureActionOverride

(Appears on: Spec, Spec)

Field | Description
--- | ---
`action` ValidationFailureAction |
`namespaces` []string |

### Variable

(Appears on: ContextEntry)

Variable defines an arbitrary JMESPath context variable that can be defined inline.

Field | Description
--- | ---
`value` Kubernetes apiextensions/v1.JSON | (Optional) Value is any arbitrary JSON object representable in YAML or JSON form.
`jmesPath` string | (Optional) JMESPath is an optional JMESPath Expression that can be used to transform the variable.
`default` Kubernetes apiextensions/v1.JSON | (Optional) Default is an optional arbitrary JSON object that the variable may take if the JMESPath expression evaluates to nil

### ViolatedRule

ViolatedRule stores the information regarding the rule.

Field | Description
--- | ---
`name` string | Name specifies violated rule name.
`type` string | Type specifies violated rule type.
`message` string | (Optional) Message specifies violation message.
`status` string | Status shows the rule response status

## kyverno.io/v1alpha2

Package v1alpha2 contains API Schema definitions for the policy v1alpha2 API group

Resource Types:

- AdmissionReport
- BackgroundScanReport
- ClusterAdmissionReport
- ClusterBackgroundScanReport

### AdmissionReport

AdmissionReport is the Schema for the AdmissionReports API

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v1alpha2`
`kind` string | `AdmissionReport`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` AdmissionReportSpec |
`owner` Kubernetes meta/v1.OwnerReference | Owner is a reference to the report owner (e.g. a Deployment, Namespace, or Node)
`summary` PolicyReportSummary | (Optional) PolicyReportSummary provides a summary of results
`results` []PolicyReportResult | (Optional) PolicyReportResult provides result details

### BackgroundScanReport

BackgroundScanReport is the Schema for the BackgroundScanReports API

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v1alpha2`
`kind` string | `BackgroundScanReport`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` BackgroundScanReportSpec |
`summary` PolicyReportSummary | (Optional) PolicyReportSummary provides a summary of results
`results` []PolicyReportResult | (Optional) PolicyReportResult provides result details

### ClusterAdmissionReport

ClusterAdmissionReport is the Schema for the ClusterAdmissionReports API

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v1alpha2`
`kind` string | `ClusterAdmissionReport`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` AdmissionReportSpec |
`owner` Kubernetes meta/v1.OwnerReference | Owner is a reference to the report owner (e.g. a Deployment, Namespace, or Node)
`summary` PolicyReportSummary | (Optional) PolicyReportSummary provides a summary of results
`results` []PolicyReportResult | (Optional) PolicyReportResult provides result details

### ClusterBackgroundScanReport

ClusterBackgroundScanReport is the Schema for the ClusterBackgroundScanReports API

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v1alpha2`
`kind` string | `ClusterBackgroundScanReport`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` BackgroundScanReportSpec |
`summary` PolicyReportSummary | (Optional) PolicyReportSummary provides a summary of results
`results` []PolicyReportResult | (Optional) PolicyReportResult provides result details

### AdmissionReportSpec

(Appears on: AdmissionReport, ClusterAdmissionReport)

Field | Description
--- | ---
`owner` Kubernetes meta/v1.OwnerReference | Owner is a reference to the report owner (e.g. a Deployment, Namespace, or Node)
`summary` PolicyReportSummary | (Optional) PolicyReportSummary provides a summary of results
`results` []PolicyReportResult | (Optional) PolicyReportResult provides result details

### BackgroundScanReportSpec

(Appears on: BackgroundScanReport, ClusterBackgroundScanReport)

Field | Description
--- | ---
`summary` PolicyReportSummary | (Optional) PolicyReportSummary provides a summary of results
`results` []PolicyReportResult | (Optional) PolicyReportResult provides result details

### ReportInterface

ReportInterface abstracts the concrete report change request type

## kyverno.io/v1beta1

Package v1beta1 contains API Schema definitions for the policy v1beta1 API group

Resource Types:

- UpdateRequest

### UpdateRequest

UpdateRequest is a request to process mutate and generate rules in background.

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v1beta1`
`kind` string | `UpdateRequest`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` UpdateRequestSpec | Spec is the information to identify the update request.
`requestType` RequestType | Type represents request type for background processing
`policy` string | Specifies the name of the policy.
`resource` ResourceSpec | ResourceSpec is the information to identify the update request.
`context` UpdateRequestSpecContext | Context …
`status` UpdateRequestStatus | (Optional) Status contains statistics related to update request.

### AdmissionRequestInfoObject

(Appears on: UpdateRequestSpecContext)

AdmissionRequestInfoObject stores the admission request and operation details

Field | Description
--- | ---
`admissionRequest` Kubernetes admission/v1.AdmissionRequest | (Optional)
`operation` Kubernetes admission/v1.Operation | (Optional)

### RequestInfo

(Appears on: UpdateRequestSpecContext)

RequestInfo contains permission info carried in an admission request.

Field | Description
--- | ---
`roles` []string | (Optional) Roles is a list of possible role send the request.
`clusterRoles` []string | (Optional) ClusterRoles is a list of possible clusterRoles send the request.
`userInfo` Kubernetes authentication/v1.UserInfo | (Optional) UserInfo is the userInfo carried in the admission request.

### RequestType (`string` alias)

(Appears on: UpdateRequestSpec)

### UpdateRequestSpec

(Appears on: UpdateRequest)

UpdateRequestSpec stores the request specification.

Field | Description
--- | ---
`requestType` RequestType | Type represents request type for background processing
`policy` string | Specifies the name of the policy.
`resource` ResourceSpec | ResourceSpec is the information to identify the update request.
`context` UpdateRequestSpecContext | Context …

### UpdateRequestSpecContext

(Appears on: UpdateRequestSpec)

UpdateRequestSpecContext stores the context to be shared.

Field | Description
--- | ---
`userInfo` RequestInfo | (Optional)
`admissionRequestInfo` AdmissionRequestInfoObject | (Optional)

### UpdateRequestState (`string` alias)

(Appears on: UpdateRequestStatus)

UpdateRequestState defines the state of request.

### UpdateRequestStatus

(Appears on: UpdateRequest)

UpdateRequestStatus defines the observed state of UpdateRequest

Field | Description
--- | ---
`handler` string | Handler represents the instance ID that handles the UR
`state` UpdateRequestState | State represents state of the update request.
`message` string | (Optional) Specifies request status message.
`generatedResources` []ResourceSpec | This will track the resources that are updated by the generate Policy. Will be used during clean up resources.

## kyverno.io/v2alpha1

Resource Types:

- CleanupPolicy
- ClusterCleanupPolicy

### CleanupPolicy

CleanupPolicy defines a rule for resource cleanup.

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v2alpha1`
`kind` string | `CleanupPolicy`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` CleanupPolicySpec | Spec declares policy behaviors.
`match` MatchResources | MatchResources defines when cleanuppolicy should be applied. The match criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the user name or role. At least one kind is required.
`exclude` MatchResources | (Optional) ExcludeResources defines when cleanuppolicy should not be applied. The exclude criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the name or role.
`schedule` string | The schedule in Cron format
`conditions` AnyAllConditions | (Optional) Conditions defines conditions used to select resources which user needs to delete
`status` CleanupPolicyStatus | (Optional) Status contains policy runtime data.

### ClusterCleanupPolicy

ClusterCleanupPolicy defines rule for resource cleanup.

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v2alpha1`
`kind` string | `ClusterCleanupPolicy`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` CleanupPolicySpec | Spec declares policy behaviors.
`match` MatchResources | MatchResources defines when cleanuppolicy should be applied. The match criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the user name or role. At least one kind is required.
`exclude` MatchResources | (Optional) ExcludeResources defines when cleanuppolicy should not be applied. The exclude criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the name or role.
`schedule` string | The schedule in Cron format
`conditions` AnyAllConditions | (Optional) Conditions defines conditions used to select resources which user needs to delete
`status` CleanupPolicyStatus | (Optional) Status contains policy runtime data.

### CleanupPolicyInterface

CleanupPolicyInterface abstracts the concrete policy type (Policy vs ClusterPolicy)

### CleanupPolicySpec

(Appears on: CleanupPolicy, ClusterCleanupPolicy)

CleanupPolicySpec stores specifications for selecting resources that the user needs to delete and schedule when the matching resources needs deleted.

Field | Description
--- | ---
`match` MatchResources | MatchResources defines when cleanuppolicy should be applied. The match criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the user name or role. At least one kind is required.
`exclude` MatchResources | (Optional) ExcludeResources defines when cleanuppolicy should not be applied. The exclude criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the name or role.
`schedule` string | The schedule in Cron format
`conditions` AnyAllConditions | (Optional) Conditions defines conditions used to select resources which user needs to delete

### CleanupPolicyStatus

(Appears on: CleanupPolicy, ClusterCleanupPolicy)

CleanupPolicyStatus stores the status of the policy.

Field | Description
--- | ---
`conditions` []Kubernetes meta/v1.Condition |

## kyverno.io/v2beta1

Resource Types:

- ClusterPolicy
- Policy

### ClusterPolicy

ClusterPolicy declares validation, mutation, and generation behaviors for matching resources.

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v2beta1`
`kind` string | `ClusterPolicy`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` Spec | Spec declares policy behaviors.
`rules` []Rule | Rules is a list of Rule instances. A Policy contains multiple rules and each rule can validate, mutate, or generate resources.
`applyRules` ApplyRulesType | (Optional) ApplyRules controls how rules in a policy are applied. Rule are processed in the order of declaration. When set to `One` processing stops after a rule has been applied i.e. the rule matches and results in a pass, fail, or error. When set to `All` all rules in the policy are processed. The default is `All`.
`failurePolicy` FailurePolicyType | (Optional) FailurePolicy defines how unexpected policy errors and webhook response timeout errors are handled. Rules within the same policy share the same failure behavior. Allowed values are Ignore or Fail. Defaults to Fail.
`validationFailureAction` ValidationFailureAction | (Optional) ValidationFailureAction defines if a validation policy rule violation should block the admission review request (enforce), or allow (audit) the admission review request and report an error in a policy report. Optional. Allowed values are audit or enforce. The default value is “audit”.
`validationFailureActionOverrides` []ValidationFailureActionOverride | (Optional) ValidationFailureActionOverrides is a Cluster Policy attribute that specifies ValidationFailureAction namespace-wise. It overrides ValidationFailureAction for the specified namespaces.
`background` bool | (Optional) Background controls if rules are applied to existing resources during a background scan. Optional. Default value is “true”. The value must be set to “false” if the policy rule uses variables that are only available in the admission review request (e.g. user name).
`schemaValidation` bool | (Optional) SchemaValidation skips validation checks for policies as well as patched resources. Optional. The default value is set to “true”, it must be set to “false” to disable the validation checks.
`webhookTimeoutSeconds` int32 | WebhookTimeoutSeconds specifies the maximum time in seconds allowed to apply this policy. After the configured time expires, the admission request may fail, or may simply ignore the policy results, based on the failure policy. The default timeout is 10s, the value must be between 1 and 30 seconds.
`mutateExistingOnPolicyUpdate` bool | (Optional) MutateExistingOnPolicyUpdate controls if a mutateExisting policy is applied on policy events. Default value is “false”.
`generateExistingOnPolicyUpdate` bool | (Optional) GenerateExistingOnPolicyUpdate controls whether to trigger generate rule in existing resources If is set to “true” generate rule will be triggered and applied to existing matched resources. Defaults to “false” if not specified.
`status` PolicyStatus | (Optional) Status contains policy runtime data.

### Policy

Policy declares validation, mutation, and generation behaviors for matching resources. See: https://kyverno.io/docs/writing-policies/ for more information.

Field | Description
--- | ---
`apiVersion` string | `kyverno.io/v2beta1`
`kind` string | `Policy`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`spec` Spec | Spec defines policy behaviors and contains one or more rules.
`rules` []Rule | Rules is a list of Rule instances. A Policy contains multiple rules and each rule can validate, mutate, or generate resources.
`applyRules` ApplyRulesType | (Optional) ApplyRules controls how rules in a policy are applied. Rule are processed in the order of declaration. When set to `One` processing stops after a rule has been applied i.e. the rule matches and results in a pass, fail, or error. When set to `All` all rules in the policy are processed. The default is `All`.
`failurePolicy` FailurePolicyType | (Optional) FailurePolicy defines how unexpected policy errors and webhook response timeout errors are handled. Rules within the same policy share the same failure behavior. Allowed values are Ignore or Fail. Defaults to Fail.
`validationFailureAction` ValidationFailureAction | (Optional) ValidationFailureAction defines if a validation policy rule violation should block the admission review request (enforce), or allow (audit) the admission review request and report an error in a policy report. Optional. Allowed values are audit or enforce. The default value is “audit”.
`validationFailureActionOverrides` []ValidationFailureActionOverride | (Optional) ValidationFailureActionOverrides is a Cluster Policy attribute that specifies ValidationFailureAction namespace-wise. It overrides ValidationFailureAction for the specified namespaces.
`background` bool | (Optional) Background controls if rules are applied to existing resources during a background scan. Optional. Default value is “true”. The value must be set to “false” if the policy rule uses variables that are only available in the admission review request (e.g. user name).
`schemaValidation` bool | (Optional) SchemaValidation skips validation checks for policies as well as patched resources. Optional. The default value is set to “true”, it must be set to “false” to disable the validation checks.
`webhookTimeoutSeconds` int32 | WebhookTimeoutSeconds specifies the maximum time in seconds allowed to apply this policy. After the configured time expires, the admission request may fail, or may simply ignore the policy results, based on the failure policy. The default timeout is 10s, the value must be between 1 and 30 seconds.
`mutateExistingOnPolicyUpdate` bool | (Optional) MutateExistingOnPolicyUpdate controls if a mutateExisting policy is applied on policy events. Default value is “false”.
`generateExistingOnPolicyUpdate` bool | (Optional) GenerateExistingOnPolicyUpdate controls whether to trigger generate rule in existing resources If is set to “true” generate rule will be triggered and applied to existing matched resources. Defaults to “false” if not specified.
`status` PolicyStatus | (Optional) Status contains policy runtime data.

### AnyAllConditions

(Appears on: CleanupPolicySpec, Deny, Rule)

Field | Description
--- | ---
`any` []Condition | (Optional) AnyConditions enable variable-based conditional rule execution. This is useful for finer control of when an rule is applied. A condition can reference object data using JMESPath notation. Here, at least one of the conditions need to pass
`all` []Condition | (Optional) AllConditions enable variable-based conditional rule execution. This is useful for finer control of when an rule is applied. A condition can reference object data using JMESPath notation. Here, all of the conditions need to pass

### Condition

(Appears on: AnyAllConditions)

Field | Description
--- | ---
`key` Kubernetes apiextensions/v1.JSON | Key is the context entry (using JMESPath) for conditional rule evaluation.
`operator` ConditionOperator | Operator is the conditional operation to perform. Valid operators are: Equals, NotEquals, In, AnyIn, AllIn, NotIn, AnyNotIn, AllNotIn, GreaterThanOrEquals, GreaterThan, LessThanOrEquals, LessThan, DurationGreaterThanOrEquals, DurationGreaterThan, DurationLessThanOrEquals, DurationLessThan
`value` Kubernetes apiextensions/v1.JSON | (Optional) Value is the conditional value, or set of values. The values can be fixed set or can be variables declared using JMESPath.

### ConditionOperator (`string` alias)

(Appears on: Condition)

ConditionOperator is the operation performed on condition key and value.

### Deny

(Appears on: Validation)

Deny specifies a list of conditions used to pass or fail a validation rule.

Field | Description
--- | ---
`conditions` AnyAllConditions | Multiple conditions can be declared under an `any` or `all` statement. A direct list of conditions (without `any` or `all` statements) is also supported for backwards compatibility See: https://kyverno.io/docs/writing-policies/validate/#deny-rules

### ImageVerification

(Appears on: Rule)

ImageVerification validates that images that match the specified pattern are signed with the supplied public key. Once the image is verified it is mutated to include the SHA digest retrieved during the registration.

Field | Description
--- | ---
`imageReferences` []string | ImageReferences is a list of matching image reference patterns. At least one pattern in the list must match the image for the rule to apply. Each image reference consists of a registry address (defaults to docker.io), repository, image, and tag (defaults to latest). Wildcards (‘*’ and ‘?’) are allowed. See: https://kubernetes.io/docs/concepts/containers/images.
`attestors` []AttestorSet | Attestors specified the required attestors (i.e. authorities)
`attestations` []Attestation | Attestations are optional checks for signed in-toto Statements used to verify the image. See https://github.com/in-toto/attestation. Kyverno fetches signed attestations from the OCI registry and decodes them into a list of Statement declarations.
`repository` string | Repository is an optional alternate OCI repository to use for image signatures and attestations that match this rule. If specified Repository will override the default OCI image repository configured for the installation. The repository can also be overridden per Attestor or Attestation.
`mutateDigest` bool | MutateDigest enables replacement of image tags with digests. Defaults to true.
`verifyDigest` bool | VerifyDigest validates that images have a digest.
`required` bool | Required validates that images are verified i.e. have matched passed a signature or attestation check.

### MatchResources

(Appears on: CleanupPolicySpec, Rule)

MatchResources is used to specify resource and admission review request data for which a policy rule is applicable.

Field | Description
--- | ---
`any` ResourceFilters | (Optional) Any allows specifying resources which will be ORed
`all` ResourceFilters | (Optional) All allows specifying resources which will be ANDed

### ResourceDescription

(Appears on: ResourceFilter)

ResourceDescription contains criteria used to match resources.

Field | Description
--- | ---
`kinds` []string | (Optional) Kinds is a list of resource kinds.
`names` []string | (Optional) Names are the names of the resources. Each name supports wildcard characters “*” (matches zero or many characters) and “?” (at least one character).
`namespaces` []string | (Optional) Namespaces is a list of namespaces names. Each name supports wildcard characters “*” (matches zero or many characters) and “?” (at least one character).
`annotations` map[string]string | (Optional) Annotations is a map of annotations (key-value pairs of type string). Annotation keys and values support the wildcard characters “*” (matches zero or many characters) and “?” (matches at least one character).
`selector` Kubernetes meta/v1.LabelSelector | (Optional) Selector is a label selector. Label keys and values in `matchLabels` support the wildcard characters `*` (matches zero or many characters) and `?` (matches one character). Wildcards allows writing label selectors like [“storage.k8s.io/”: “”]. Note that using [”” : “”] matches any key and value but does not match an empty label set.
`namespaceSelector` Kubernetes meta/v1.LabelSelector | (Optional) NamespaceSelector is a label selector for the resource namespace. Label keys and values in `matchLabels` support the wildcard characters `*` (matches zero or many characters) and `?` (matches one character).Wildcards allows writing label selectors like [“storage.k8s.io/”: “”]. Note that using [”” : “”] matches any key and value but does not match an empty label set.

### ResourceFilter

ResourceFilter allow users to “AND” or “OR” between resources

Field | Description
--- | ---
`UserInfo` UserInfo | (Optional) UserInfo contains information about the user performing the operation.
`resources` ResourceDescription | ResourceDescription contains information about the resource being created or modified.

### ResourceFilters (`[]github.com/kyverno/kyverno/api/kyverno/v2beta1.ResourceFilter` alias)

ResourceFilters is a slice of ResourceFilter

### Rule

(Appears on: Spec)

Rule defines a validation, mutation, or generation control for matching resources. Each rules contains a match declaration to select resources, and an optional exclude declaration to specify which resources to exclude.

Field | Description
--- | ---
`name` string | Name is a label to identify the rule, It must be unique within the policy.
`context` []ContextEntry | (Optional) Context defines variables and data sources that can be used during rule execution.
`match` MatchResources | MatchResources defines when this policy rule should be applied. The match criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the user name or role. At least one kind is required.
`exclude` MatchResources | (Optional) ExcludeResources defines when this policy rule should not be applied. The exclude criteria can include resource information (e.g. kind, name, namespace, labels) and admission review request information like the name or role.
`imageExtractors` ImageExtractorConfigs | (Optional) ImageExtractors defines a mapping from kinds to ImageExtractorConfigs. This config is only valid for verifyImages rules.
`preconditions` AnyAllConditions | (Optional) Preconditions are used to determine if a policy rule should be applied by evaluating a set of conditions. The declaration can contain nested `any` or `all` statements. A direct list of conditions (without `any` or `all` statements is supported for backwards compatibility but See: https://kyverno.io/docs/writing-policies/preconditions/
`mutate` Mutation | (Optional) Mutation is used to modify matching resources.
`validate` Validation | (Optional) Validation is used to validate matching resources.
`generate` Generation | (Optional) Generation is used to create new resources.
`verifyImages` []ImageVerification | (Optional) VerifyImages is used to verify image signatures and mutate them to add a digest

### Spec

(Appears on: ClusterPolicy, Policy)

Spec contains a list of Rule instances and other policy controls.

Field | Description
--- | ---
`rules` []Rule | Rules is a list of Rule instances. A Policy contains multiple rules and each rule can validate, mutate, or generate resources.
`applyRules` ApplyRulesType | (Optional) ApplyRules controls how rules in a policy are applied. Rule are processed in the order of declaration. When set to `One` processing stops after a rule has been applied i.e. the rule matches and results in a pass, fail, or error. When set to `All` all rules in the policy are processed. The default is `All`.
`failurePolicy` FailurePolicyType | (Optional) FailurePolicy defines how unexpected policy errors and webhook response timeout errors are handled. Rules within the same policy share the same failure behavior. Allowed values are Ignore or Fail. Defaults to Fail.
`validationFailureAction` ValidationFailureAction | (Optional) ValidationFailureAction defines if a validation policy rule violation should block the admission review request (enforce), or allow (audit) the admission review request and report an error in a policy report. Optional. Allowed values are audit or enforce. The default value is “audit”.
`validationFailureActionOverrides` []ValidationFailureActionOverride | (Optional) ValidationFailureActionOverrides is a Cluster Policy attribute that specifies ValidationFailureAction namespace-wise. It overrides ValidationFailureAction for the specified namespaces.
`background` bool | (Optional) Background controls if rules are applied to existing resources during a background scan. Optional. Default value is “true”. The value must be set to “false” if the policy rule uses variables that are only available in the admission review request (e.g. user name).
`schemaValidation` bool | (Optional) SchemaValidation skips validation checks for policies as well as patched resources. Optional. The default value is set to “true”, it must be set to “false” to disable the validation checks.
`webhookTimeoutSeconds` int32 | WebhookTimeoutSeconds specifies the maximum time in seconds allowed to apply this policy. After the configured time expires, the admission request may fail, or may simply ignore the policy results, based on the failure policy. The default timeout is 10s, the value must be between 1 and 30 seconds.
`mutateExistingOnPolicyUpdate` bool | (Optional) MutateExistingOnPolicyUpdate controls if a mutateExisting policy is applied on policy events. Default value is “false”.
`generateExistingOnPolicyUpdate` bool | (Optional) GenerateExistingOnPolicyUpdate controls whether to trigger generate rule in existing resources If is set to “true” generate rule will be triggered and applied to existing matched resources. Defaults to “false” if not specified.

### Validation

(Appears on: Rule)

Validation defines checks to be performed on matching resources.

Field | Description
--- | ---
`message` string | (Optional) Message specifies a custom message to be displayed on failure.
`manifests` Manifests | (Optional) Manifest specifies conditions for manifest verification
`foreach` []ForEachValidation | (Optional) ForEach applies validate rules to a list of sub-elements by creating a context for each entry in the list and looping over it to apply the specified logic.
`pattern` Kubernetes apiextensions/v1.JSON | (Optional) Pattern specifies an overlay-style pattern used to check resources.
`anyPattern` Kubernetes apiextensions/v1.JSON | (Optional) AnyPattern specifies list of validation patterns. At least one of the patterns must be satisfied for the validation rule to succeed.
`deny` Deny | (Optional) Deny defines conditions used to pass or fail a validation rule.
`podSecurity` PodSecurity | (Optional) PodSecurity applies exemptions for Kubernetes Pod Security admission by specifying exclusions for Pod Security Standards controls.

## wgpolicyk8s.io/v1alpha2

Resource Types:

- ClusterPolicyReport
- PolicyReport

### ClusterPolicyReport

ClusterPolicyReport is the Schema for the clusterpolicyreports API

Field | Description
--- | ---
`apiVersion` string | `wgpolicyk8s.io/v1alpha2`
`kind` string | `ClusterPolicyReport`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`scope` Kubernetes core/v1.ObjectReference | (Optional) Scope is an optional reference to the report scope (e.g. a Deployment, Namespace, or Node)
`scopeSelector` Kubernetes meta/v1.LabelSelector | (Optional) ScopeSelector is an optional selector for multiple scopes (e.g. Pods). Either one of, or none of, but not both of, Scope or ScopeSelector should be specified.
`summary` PolicyReportSummary | (Optional) PolicyReportSummary provides a summary of results
`results` []PolicyReportResult | (Optional) PolicyReportResult provides result details

### PolicyReport

PolicyReport is the Schema for the policyreports API

Field | Description
--- | ---
`apiVersion` string | `wgpolicyk8s.io/v1alpha2`
`kind` string | `PolicyReport`
`metadata` Kubernetes meta/v1.ObjectMeta | Refer to the Kubernetes API documentation for the fields of the `metadata` field.
`scope` Kubernetes core/v1.ObjectReference | (Optional) Scope is an optional reference to the report scope (e.g. a Deployment, Namespace, or Node)
`scopeSelector` Kubernetes meta/v1.LabelSelector | (Optional) ScopeSelector is an optional selector for multiple scopes (e.g. Pods). Either one of, or none of, but not both of, Scope or ScopeSelector should be specified.
`summary` PolicyReportSummary | (Optional) PolicyReportSummary provides a summary of results
`results` []PolicyReportResult | (Optional) PolicyReportResult provides result details

### PolicyReportResult

(Appears on: ClusterPolicyReport, PolicyReport, AdmissionReportSpec, BackgroundScanReportSpec)

PolicyReportResult provides the result for an individual policy

Field | Description
--- | ---
`source` string | (Optional) Source is an identifier for the policy engine that manages this report
`policy` string | Policy is the name or identifier of the policy
`rule` string | (Optional) Rule is the name or identifier of the rule within the policy
`resources` []Kubernetes core/v1.ObjectReference | (Optional) Subjects is an optional reference to the checked Kubernetes resources
`resourceSelector` Kubernetes meta/v1.LabelSelector | (Optional) SubjectSelector is an optional label selector for checked Kubernetes resources. For example, a policy result may apply to all pods that match a label. Either a Subject or a SubjectSelector can be specified. If neither are provided, the result is assumed to be for the policy report scope.
`message` string | Description is a short user friendly message for the policy rule
`result` PolicyResult | Result indicates the outcome of the policy rule execution
`scored` bool | Scored indicates if this result is scored
`properties` map[string]string | Properties provides additional information for the policy rule
`timestamp` Kubernetes meta/v1.Timestamp | Timestamp indicates the time the result was found
`category` string | (Optional) Category indicates policy category
`severity` PolicySeverity | (Optional) Severity indicates policy check result criticality

### PolicyReportSummary

(Appears on: ClusterPolicyReport, PolicyReport, AdmissionReportSpec, BackgroundScanReportSpec)

PolicyReportSummary provides a status count summary

Field | Description
--- | ---
`pass` int | (Optional) Pass provides the count of policies whose requirements were met
`fail` int | (Optional) Fail provides the count of policies whose requirements were not met
`warn` int | (Optional) Warn provides the count of non-scored policies whose requirements were not met
`error` int | (Optional) Error provides the count of policies that could not be evaluated
`skip` int | (Optional) Skip indicates the count of policies that were not selected for evaluation

### PolicyResult (`string` alias)

(Appears on: PolicyReportResult)

PolicyResult has one of the following values: - pass: indicates that the policy requirements are met - fail: indicates that the policy requirements are not met - warn: indicates that the policy requirements and not met, and the policy is not scored - error: indicates that the policy could not be evaluated - skip: indicates that the policy was not selected based on user inputs or applicability

### PolicySeverity (`string` alias)

(Appears on: PolicyReportResult)

PolicySeverity has one of the following values: - critical - high - low - medium - info